% This code generates Figure 6e from oude Lohuis et al., 2022.
% Per session, optogenetic D-prime reduction is plotted versus 
% reaction time for MST/UST Thr/Max.
% This code uses the data structure "BehLat". 
% BehLat is saved in Data6_3, and is generated by the script Build_BehLat in Fig6D
% For any questions contact Umberto Olcese at u.olcese@uva.nl

%% Insert directory where OudeLohuisetal_2022_NatComms is saved:
maindirectory = 'C:\Users\jeanl\surfdrive\Shared\Manuscript - 2nd Bump\Submission - NatComm\rev2';

%% Load "BehLat" in
load( strcat(maindirectory,'\OudeLohuisetal_2022_NatComms\6VisuotactileTask\Data6_3\BehLat.mat') );

%% NEW STATISTICS : Linear Mixed Effects Model ------------------------------
%Take into account data nestedness, therefore must obtain mouse ID

%Load the data in BehLat -----------------------------------------------
%prep ------------------------------------------------------------------
sessionnames = categorical({BehLat.SessionName});
sessionnum = double(sessionnames);
for i=1:length(BehLat)
    SN = BehLat(i).SessionName;
    BehLat(i).Mouse = SN(strfind(SN,'J'):strfind(SN,'J')+3);
end

%d-prime reduction ~ RT + (1|mouse) -----------------------------------
%First all together
tbl = struct2table( BehLat(strcmp({BehLat.Side},'Contra') & strcmp({BehLat.Modality},'Visual') & strcmp({BehLat.Silencing},'Late') & ~isnan([BehLat.Dprime])) );
tbl.Mouse       = categorical(tbl.Mouse);
tbl.Task       = categorical(tbl.Task);
tbl.Saliency       = categorical(tbl.Saliency);
lme = fitlme(tbl,'DprimeReduction ~ RTctrlmed + (1|Mouse)');
stats = dataset2table(anova(lme,'DFMethod','Satterthwaite')); 
fprintf('Linear Mixed Model (Vis Contra LATE:)\n')
fprintf('F(%d,%2.0f)=%1.2f, p=%1.3f; \n',stats{2,3},stats{2,4},stats{2,2},stats{2,5})
p1 = stats{2,5}

%Plot
figure(); hold on
scatter(tbl.RTctrlmed(tbl.Task=='tMulti' & tbl.Saliency=='Low'),  tbl.DprimeReduction(tbl.Task=='tMulti' & tbl.Saliency=='Low'),[],[.8 0 .8])
scatter(tbl.RTctrlmed(tbl.Task=='tMulti' & tbl.Saliency=='High'),  tbl.DprimeReduction(tbl.Task=='tMulti' & tbl.Saliency=='High'),[],[.8 0 .8],'filled')
scatter(tbl.RTctrlmed(tbl.Task=='tUni' & tbl.Saliency=='Low'),  tbl.DprimeReduction(tbl.Task=='tUni' & tbl.Saliency=='Low'),[],[.8 .8 0])
scatter(tbl.RTctrlmed(tbl.Task=='tUni' & tbl.Saliency=='High'),  tbl.DprimeReduction(tbl.Task=='tUni' & tbl.Saliency=='High'),[],[.8 .8 0],'filled')
xlim([0.3 0.85])
ylim([-0.5 2])
%Add lines at 0 and 100% for visualization
xx = xlim;
line([xx(1) xx(2)],[0 0],'Color',[.6 .6 .6],'LineWidth',1)
line([xx(1) xx(2)],[1 1],'Color',[.6 .6 .6],'LineWidth',1)
%Add fit line
coef = lme.Coefficients.Estimate;
line([0 1],[coef(1) coef(2)+coef(1)],'Color',[0 0 0],'LineWidth',2)